Source-Changes-HG archive

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]

[src/trunk]: src Test orphan ELF section placement.



details:   https://anonhg.NetBSD.org/src/rev/8bb25de7de00
branches:  trunk
changeset: 803847:8bb25de7de00
user:      uebayasi <uebayasi%NetBSD.org@localhost>
date:      Fri Nov 14 16:21:12 2014 +0000

description:
Test orphan ELF section placement.

diffstat:

 distrib/sets/lists/tests/mi  |   3 +-
 tests/usr.bin/ld/Makefile    |   5 +-
 tests/usr.bin/ld/t_orphan.sh |  77 ++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 82 insertions(+), 3 deletions(-)

diffs (115 lines):

diff -r 51310eca183c -r 8bb25de7de00 distrib/sets/lists/tests/mi
--- a/distrib/sets/lists/tests/mi       Fri Nov 14 16:20:42 2014 +0000
+++ b/distrib/sets/lists/tests/mi       Fri Nov 14 16:21:12 2014 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: mi,v 1.598 2014/11/14 13:30:48 uebayasi Exp $
+# $NetBSD: mi,v 1.599 2014/11/14 16:21:12 uebayasi Exp $
 #
 # Note: don't delete entries from here - mark them as "obsolete" instead.
 #
@@ -3466,6 +3466,7 @@
 ./usr/tests/usr.bin/ld                         tests-usr.bin-tests
 ./usr/tests/usr.bin/ld/Atffile                 tests-usr.bin-tests     atf
 ./usr/tests/usr.bin/ld/Kyuafile                        tests-usr.bin-tests     atf,kyua
+./usr/tests/usr.bin/ld/t_orphan                        tests-usr.bin-tests     atf
 ./usr/tests/usr.bin/ld/t_script                        tests-usr.bin-tests     atf
 ./usr/tests/usr.bin/ld/t_section               tests-usr.bin-tests     atf
 ./usr/tests/usr.bin/m4                         tests-usr.bin-tests
diff -r 51310eca183c -r 8bb25de7de00 tests/usr.bin/ld/Makefile
--- a/tests/usr.bin/ld/Makefile Fri Nov 14 16:20:42 2014 +0000
+++ b/tests/usr.bin/ld/Makefile Fri Nov 14 16:21:12 2014 +0000
@@ -1,10 +1,11 @@
-# $NetBSD: Makefile,v 1.2 2014/11/14 13:30:48 uebayasi Exp $
+# $NetBSD: Makefile,v 1.3 2014/11/14 16:21:12 uebayasi Exp $
 
 .include <bsd.own.mk>
 
 TESTSDIR=      ${TESTSBASE}/usr.bin/ld
 
-TESTS_SH=      t_script \
+TESTS_SH=      t_orphan \
+               t_script \
                t_section
 
 .include <bsd.test.mk>
diff -r 51310eca183c -r 8bb25de7de00 tests/usr.bin/ld/t_orphan.sh
--- /dev/null   Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/usr.bin/ld/t_orphan.sh      Fri Nov 14 16:21:12 2014 +0000
@@ -0,0 +1,77 @@
+#      $NetBSD: t_orphan.sh,v 1.1 2014/11/14 16:21:12 uebayasi Exp $
+#
+# Copyright (c) 2014 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+
+atf_test_case orphan
+orphan_head() {
+       atf_set "descr" "check orphan section placement"
+       atf_set "require.progs" "cc" "readelf" "grep"
+}
+
+orphan_body() {
+       cat > test.c << EOF
+#include <sys/cdefs.h>
+/* read-only orphan */
+const char a[] __section("hoge") = { 'h', 'o', 'g', 'e', '\0' };
+/* read-write orphan */
+char b[] __section("fuga") = "fuga";
+/* .data */
+int c = 123;
+/* .bss */
+int d = 0;
+/* .text */
+int main(void) { return 0; }
+EOF
+       atf_check -s exit:0 -o ignore -e ignore cc -o test test.c
+       readelf -S test
+       readelf -S test |
+       grep ' \.text\| hoge\| \.data\| fuga\| \.bss' >test.secs
+       {
+               # Read-only orphan sections are placed after well-known
+               # read-only sections (.text, .rodata) but before .data
+               read line && match "$line" ".text" &&
+               read line && match "$line" "hoge" &&
+               # Read-write orphan sections are placed after well-known
+               # read-write sections (.data) but before .bss
+               read line && match "$line" ".data" &&
+               read line && match "$line" "fuga" &&
+               read line && match "$line" ".bss" &&
+               :
+       } < test.secs
+       atf_check test "$?" -eq 0
+}
+
+match() {
+       case "$1" in
+       *"$2"*) return 0;
+       esac
+       return 1
+}
+
+atf_init_test_cases()
+{
+       atf_add_test_case orphan
+}



Home | Main Index | Thread Index | Old Index